'===============================================================
' Stock Ticker
'===============================================================
'
' Builds a string of stock prices and changes from an array
' by querying Yahoo Finance. Using horizontal scrolling in
' Samurize simulates a stock ticker.
'
' Uses code extracted from the Kapsules Widget: Bobs Stocks.
'

'---------------------------------------------------------------
' Enter Yahoo stock symbols in the symbol array below enclosed
' in quotes. Terminate the array with a value Null. Use the
' optional name array to associate a different name with each
' symbol. If the name is Null, the symbol will be used.

Dim symbol, name
symbol = array("^dji","^ixic","^spb","QQQQ","MSFT","INTC",Null)
name = array("DJIA","NASDAQ","S&P 500",Null,Null,Null,Null)

'---------------------------------------------------------------

Function StockTicker()
	Dim webPage, x, stockString
	x = 0
	stockString = ""
	Do Until IsNull(symbol(x))
		If IsNull(name(x)) Then
			symbolName = symbol(x)
		Else
			symbolName = name(x)
		End If
		webPage = GetUrl("http://finance.yahoo.com/q?s=" & symbol(x) & "&" & Now())
		If webPage = "" Or InStr(webPage,"yfnc_tabledata") = 0 Then
			StockText = "No Data"
			Exit Function
		End If
		webPage = Mid(webPage,InStr(webPage,"yfnc_tabledata")+17+8)
		price = Mid(webPage,1,InStr(webPage,"<")-1)
		webPage = Mid(webPage,InStr(webPage,"yfnc_tabledata")+17)
		updatetime = Mid(webPage,1,InStr(webPage,"<")-1)
		webPage = Mid(webPage,InStr(webPage,"yfnc_tabledata")+17)
		changeSign = Mid(webPage,InStr(webPage, "alt")+5)
		changeSign = Mid(changeSign,1,1)
		webPage = Mid(webPage,InStr(webPage,";" + chr(34))+3)
		change = Mid(webPage,1,InStr(webPage,"<")-1)
		If Left(changeSign,1) = "D" Then
			change = "-" & change
		Else
			change = "+" & change
		End if
		stockString = stockString & symbolName & ": " & price & " " & change & "  |  "
		x = x + 1
	Loop
	StockTicker = "       [ " & updatetime & " ]  " & Mid(stockString, 1, Len(stockString)-5)
End Function

Private Function GetUrl(strURL)
	On Error Resume Next
	Dim objXML
	set objXML = CreateObject("Msxml2.XMLHTTP")
	objXML.open "GET", strURL, false
	objXML.send
	GetUrl = Mid(objXML.responseText,1)
	Set objXML = Nothing
End Function
